/*******************************************************************************
 * Pattern signature of the uml.generateUML.classesOperation pattern
 * Generated by EMF-IncQuery
 *******************************************************************************/

package signatures.uml.generateUML;

import java.util.Arrays;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.viatra2.emf.incquery.runtime.api.IPatternSignature;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BasePatternSignature;

/**
 * Pattern-specific signature object of the uml.generateUML.classesOperation pattern.
 * Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters, 
 * usable e.g. to represent a match of the pattern in the result of a query, 
 * or to specify the bound (fixed) input parameters when issuing a query.
 */
@SuppressWarnings("unused")
public final class ClassesOperationSignature extends BasePatternSignature implements IPatternSignature {

	// constructor
	public ClassesOperationSignature(Object C, Object O) {
		this.fC = C;
		this.fO = O;	
	}

	//private attributes
	private Object fC;
	private Object fO;
	
	// getter methods
	/** Returns the value of the parameter with the given name, or null if name is invalid. */
	@Override
	public Object get(String parameterName) {
		if ("C".equals(parameterName)) return fC;
		if ("O".equals(parameterName)) return fO;
		return null;
	}	
	
	public Object getValueOfC(){
		 return fC;
	}
	public Object getValueOfO(){
		 return fO;
	}	
	
	// setter methods
	/** 
	 * Sets the parameter with the given name to the given value. 
	 * @returns true if successful, false if parameter name is invalid. May also fail and return false if the value type is incompatible. 
	 */
	@Override
	public boolean set(String parameterName, Object newValue) {
		if ("C".equals(parameterName)) {
			fC = newValue;
			return true;
		}
		if ("O".equals(parameterName)) {
			fO = newValue;
			return true;
		}
		return false;
	}
	
	public void setValueOfC(Object C){
		 this.fC=C;
	}
	public void setValueOfO(Object O){
		 this.fO=O;
	}

	// overridden prettyPrint(), hashCode(), equals() with Tuple-semantics
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (! (obj instanceof IPatternSignature))
			return false;
		IPatternSignature otherSig = (IPatternSignature) obj;
		if (!patternName().equals(otherSig.patternName()))
			return false;
		if (!ClassesOperationSignature.class.equals(obj.getClass()))
			return Arrays.deepEquals(toArray(), otherSig.toArray());
		ClassesOperationSignature other = (ClassesOperationSignature) obj;
		if (fC == null) {if (other.fC != null) return false;}
		else if (!fC.equals(other.fC)) return false;
		if (fO == null) {if (other.fO != null) return false;}
		else if (!fO.equals(other.fO)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fC == null) ? 0 : fC.hashCode());
		result = prime * result + ((fO == null) ? 0 : fO.hashCode());
		return result;
	}

	@Override
	public String prettyPrint() {
		StringBuilder result = new StringBuilder();
		result.append("\"C\"=" + prettyPrintValue(fC));
		result.append(", \"O\"=" + prettyPrintValue(fO));
		return result.toString();
	}

	// conversion and reflection
	/** Converts the signature to an array representation, with each pattern parameter at their respective position */
	@Override
	public Object[] toArray() {
		return new Object[] {fC, fO};
	}
	
	/** Identifies the name of the pattern for which this is a signature. */
	@Override
	public String patternName() {
		return "uml.generateUML.classesOperation";
	}
	
	/** Returns the list of symbolic parameter names. */
	@Override
	public String[] parameterNames() {
		return parameterNames;
	}
	private static String[] parameterNames = {"C", "O"};
	
	
}
