/*******************************************************************************
 * Pattern signature of the uml.generateUML.modelElementsToClone pattern
 * Generated by EMF-IncQuery
 *******************************************************************************/

package signatures.uml.generateUML;

import java.util.Arrays;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.viatra2.emf.incquery.runtime.api.IPatternSignature;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BasePatternSignature;

/**
 * Pattern-specific signature object of the uml.generateUML.modelElementsToClone pattern.
 * Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters, 
 * usable e.g. to represent a match of the pattern in the result of a query, 
 * or to specify the bound (fixed) input parameters when issuing a query.
 */
@SuppressWarnings("unused")
public final class ModelElementsToCloneSignature extends BasePatternSignature implements IPatternSignature {

	// constructor
	public ModelElementsToCloneSignature(Object Class, Object StMach, Object Trigger, Object Operation, Object Behavior) {
		this.fClass = Class;
		this.fStMach = StMach;
		this.fTrigger = Trigger;
		this.fOperation = Operation;
		this.fBehavior = Behavior;	
	}

	//private attributes
	private Object fClass;
	private Object fStMach;
	private Object fTrigger;
	private Object fOperation;
	private Object fBehavior;
	
	// getter methods
	/** Returns the value of the parameter with the given name, or null if name is invalid. */
	@Override
	public Object get(String parameterName) {
		if ("Class".equals(parameterName)) return fClass;
		if ("StMach".equals(parameterName)) return fStMach;
		if ("Trigger".equals(parameterName)) return fTrigger;
		if ("Operation".equals(parameterName)) return fOperation;
		if ("Behavior".equals(parameterName)) return fBehavior;
		return null;
	}	
	
	public Object getValueOfClass(){
		 return fClass;
	}
	public Object getValueOfStMach(){
		 return fStMach;
	}
	public Object getValueOfTrigger(){
		 return fTrigger;
	}
	public Object getValueOfOperation(){
		 return fOperation;
	}
	public Object getValueOfBehavior(){
		 return fBehavior;
	}	
	
	// setter methods
	/** 
	 * Sets the parameter with the given name to the given value. 
	 * @returns true if successful, false if parameter name is invalid. May also fail and return false if the value type is incompatible. 
	 */
	@Override
	public boolean set(String parameterName, Object newValue) {
		if ("Class".equals(parameterName)) {
			fClass = newValue;
			return true;
		}
		if ("StMach".equals(parameterName)) {
			fStMach = newValue;
			return true;
		}
		if ("Trigger".equals(parameterName)) {
			fTrigger = newValue;
			return true;
		}
		if ("Operation".equals(parameterName)) {
			fOperation = newValue;
			return true;
		}
		if ("Behavior".equals(parameterName)) {
			fBehavior = newValue;
			return true;
		}
		return false;
	}
	
	public void setValueOfClass(Object Class){
		 this.fClass=Class;
	}
	public void setValueOfStMach(Object StMach){
		 this.fStMach=StMach;
	}
	public void setValueOfTrigger(Object Trigger){
		 this.fTrigger=Trigger;
	}
	public void setValueOfOperation(Object Operation){
		 this.fOperation=Operation;
	}
	public void setValueOfBehavior(Object Behavior){
		 this.fBehavior=Behavior;
	}

	// overridden prettyPrint(), hashCode(), equals() with Tuple-semantics
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (! (obj instanceof IPatternSignature))
			return false;
		IPatternSignature otherSig = (IPatternSignature) obj;
		if (!patternName().equals(otherSig.patternName()))
			return false;
		if (!ModelElementsToCloneSignature.class.equals(obj.getClass()))
			return Arrays.deepEquals(toArray(), otherSig.toArray());
		ModelElementsToCloneSignature other = (ModelElementsToCloneSignature) obj;
		if (fClass == null) {if (other.fClass != null) return false;}
		else if (!fClass.equals(other.fClass)) return false;
		if (fStMach == null) {if (other.fStMach != null) return false;}
		else if (!fStMach.equals(other.fStMach)) return false;
		if (fTrigger == null) {if (other.fTrigger != null) return false;}
		else if (!fTrigger.equals(other.fTrigger)) return false;
		if (fOperation == null) {if (other.fOperation != null) return false;}
		else if (!fOperation.equals(other.fOperation)) return false;
		if (fBehavior == null) {if (other.fBehavior != null) return false;}
		else if (!fBehavior.equals(other.fBehavior)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fClass == null) ? 0 : fClass.hashCode());
		result = prime * result + ((fStMach == null) ? 0 : fStMach.hashCode());
		result = prime * result + ((fTrigger == null) ? 0 : fTrigger.hashCode());
		result = prime * result + ((fOperation == null) ? 0 : fOperation.hashCode());
		result = prime * result + ((fBehavior == null) ? 0 : fBehavior.hashCode());
		return result;
	}

	@Override
	public String prettyPrint() {
		StringBuilder result = new StringBuilder();
		result.append("\"Class\"=" + prettyPrintValue(fClass));
		result.append(", \"StMach\"=" + prettyPrintValue(fStMach));
		result.append(", \"Trigger\"=" + prettyPrintValue(fTrigger));
		result.append(", \"Operation\"=" + prettyPrintValue(fOperation));
		result.append(", \"Behavior\"=" + prettyPrintValue(fBehavior));
		return result.toString();
	}

	// conversion and reflection
	/** Converts the signature to an array representation, with each pattern parameter at their respective position */
	@Override
	public Object[] toArray() {
		return new Object[] {fClass, fStMach, fTrigger, fOperation, fBehavior};
	}
	
	/** Identifies the name of the pattern for which this is a signature. */
	@Override
	public String patternName() {
		return "uml.generateUML.modelElementsToClone";
	}
	
	/** Returns the list of symbolic parameter names. */
	@Override
	public String[] parameterNames() {
		return parameterNames;
	}
	private static String[] parameterNames = {"Class", "StMach", "Trigger", "Operation", "Behavior"};
	
	
}
