/*******************************************************************************
 * Pattern signature of the uml.generateUML.triggersSignal pattern
 * Generated by EMF-IncQuery
 *******************************************************************************/

package signatures.uml.generateUML;

import java.util.Arrays;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.viatra2.emf.incquery.runtime.api.IPatternSignature;
import org.eclipse.viatra2.emf.incquery.runtime.api.impl.BasePatternSignature;

/**
 * Pattern-specific signature object of the uml.generateUML.triggersSignal pattern.
 * Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters, 
 * usable e.g. to represent a match of the pattern in the result of a query, 
 * or to specify the bound (fixed) input parameters when issuing a query.
 */
@SuppressWarnings("unused")
public final class TriggersSignalSignature extends BasePatternSignature implements IPatternSignature {

	// constructor
	public TriggersSignalSignature(Object T, Object S1) {
		this.fT = T;
		this.fS1 = S1;	
	}

	//private attributes
	private Object fT;
	private Object fS1;
	
	// getter methods
	/** Returns the value of the parameter with the given name, or null if name is invalid. */
	@Override
	public Object get(String parameterName) {
		if ("T".equals(parameterName)) return fT;
		if ("S1".equals(parameterName)) return fS1;
		return null;
	}	
	
	public Object getValueOfT(){
		 return fT;
	}
	public Object getValueOfS1(){
		 return fS1;
	}	
	
	// setter methods
	/** 
	 * Sets the parameter with the given name to the given value. 
	 * @returns true if successful, false if parameter name is invalid. May also fail and return false if the value type is incompatible. 
	 */
	@Override
	public boolean set(String parameterName, Object newValue) {
		if ("T".equals(parameterName)) {
			fT = newValue;
			return true;
		}
		if ("S1".equals(parameterName)) {
			fS1 = newValue;
			return true;
		}
		return false;
	}
	
	public void setValueOfT(Object T){
		 this.fT=T;
	}
	public void setValueOfS1(Object S1){
		 this.fS1=S1;
	}

	// overridden prettyPrint(), hashCode(), equals() with Tuple-semantics
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (! (obj instanceof IPatternSignature))
			return false;
		IPatternSignature otherSig = (IPatternSignature) obj;
		if (!patternName().equals(otherSig.patternName()))
			return false;
		if (!TriggersSignalSignature.class.equals(obj.getClass()))
			return Arrays.deepEquals(toArray(), otherSig.toArray());
		TriggersSignalSignature other = (TriggersSignalSignature) obj;
		if (fT == null) {if (other.fT != null) return false;}
		else if (!fT.equals(other.fT)) return false;
		if (fS1 == null) {if (other.fS1 != null) return false;}
		else if (!fS1.equals(other.fS1)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fT == null) ? 0 : fT.hashCode());
		result = prime * result + ((fS1 == null) ? 0 : fS1.hashCode());
		return result;
	}

	@Override
	public String prettyPrint() {
		StringBuilder result = new StringBuilder();
		result.append("\"T\"=" + prettyPrintValue(fT));
		result.append(", \"S1\"=" + prettyPrintValue(fS1));
		return result.toString();
	}

	// conversion and reflection
	/** Converts the signature to an array representation, with each pattern parameter at their respective position */
	@Override
	public Object[] toArray() {
		return new Object[] {fT, fS1};
	}
	
	/** Identifies the name of the pattern for which this is a signature. */
	@Override
	public String patternName() {
		return "uml.generateUML.triggersSignal";
	}
	
	/** Returns the list of symbolic parameter names. */
	@Override
	public String[] parameterNames() {
		return parameterNames;
	}
	private static String[] parameterNames = {"T", "S1"};
	
	
}
